﻿using System;
using System.Net;
using System.Web.Mvc;
using Newtonsoft.Json.Linq;
using SampleMVC4Rest.Models;

namespace SampleMVC4Rest.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Rest Json Example";
            return View(new SendSMSViewModel());
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

        public ActionResult SendMessage(SendSMSViewModel model)
        {
            ViewBag.Message = "REST / JSON Example";

            // *************************************
            // NOTE: Put your account key here: 
            const string key="Your Account Key Goes Here";
            // *************************************

            var url = string.Format("http://smsgateway.ca/services/message.svc/{1}/{0}", model.CellNumber, key);

            var serviceRequest = new WebClient();
            serviceRequest.Headers[HttpRequestHeader.ContentType] = "application/JSON";
            var jsonStringParams = string.Format("{{\"MessageBody\":\"{0}\",\"Reference\":\"{1}\"}}", model.MessageBody,model.Reference);

            try
            {
                var response  = serviceRequest.UploadString(url, "POST", jsonStringParams);
                var jsonObject = JObject.Parse(response);
                model.Response = (string) jsonObject["SendMessageWithReferenceResult"];
            }
            catch (Exception er)
            {
                model.ErrorMessage = er.Message;
            }
            
            return View(model);
        }
    }
}
